//
//  MyDrawNode.cpp
//  spirograph-mobile
//
//  Created by Reza Ghobadinic on 2018-10-23.
//

#include <iostream>
#include <cstdlib>

#include "MyDrawNode.hpp"

using namespace cocos2d;
using namespace std;

Node* MyDrawNode::createNode()
{
    return DrawNode::create(); // Create an instance of this class and return the pointer
}

bool MyDrawNode::init()
{
    if(!Node::init())
    {
        return false;
    }
    
    srand(time(NULL));
    
    i = 0;
    radius1 = rand() % 100 + 150; // Random between 150 to 250
    radius2 = rand() % 100 + 50; // Random between 50 to 150
    multi = 0.53;
    delta = 0.2;
    
    firstPoint = Vec2(0, 0);
    secondPoint = Vec2(0, 0);
    
    // Screen coordinates
    auto visibleSize = Director::getInstance()->getVisibleSize(); // Screen's visible size
    Vec2 origin = Director::getInstance()->getVisibleOrigin();    // Screen's visible origin
    
    // Calculating the center of the screen
    float cx = origin.x + visibleSize.width * 0.5;  // X for the center of the screen
    float cy = origin.y + visibleSize.height * 0.5; // Y for the center of the screen
    
    this->setPosition(cx, cy);
    
    //scheduleUpdate(); // Activate the update function to be called on every frame
    return true;
}

void MyDrawNode::draw(Renderer* renderer, const Mat4& transform, uint32_t flags)
{
    secondPoint.x = radius1 * cos(i * multi) + radius2 * sin(i * 1.1); // Calculating X for the end point
    secondPoint.y = radius1 * sin(i * multi) + radius2 * cos(i * 1.1); // Calculating Y for the end point
    
    if (i < 800.0)
    {
        i += delta;
        
        if(firstPoint == Vec2(0,0))
            firstPoint = secondPoint;
        
        auto draw = DrawNode::create(); // Create a drawNode object that draws simple shapes
        draw->drawLine(firstPoint, secondPoint, Color4F(1.0, 1.0, 1.0, 1.0)); // Draw a line from the start point to the end point
        firstPoint = secondPoint;
        
        this->addChild(draw); // Parenting the drawn object to this node
    }
}
/*
void MyDrawNode::update(float delta)
{
    auto rotation = this->getRotation();    // Get the current rotation of self
    rotation += 0.1;                        // Increase the current rotation
    this->setRotation(rotation);            // Set the rotation to the newly increased value
}
*/
